void drawCircles(float portion){
        //reference: https://github.com/mohithingorani/Extruding-Circos-3D-Interactive-Data-Visualization
       pushMatrix(); 
       noFill();
       stroke(0,0,100,150);
       translate(0,0,portion * step);
       ellipse(0,0,radius,radius);
       popMatrix();
}

void drawArc( float portion) {
         //reference: https://github.com/mohithingorani/Extruding-Circos-3D-Interactive-Data-Visualization
        portion++;
        pushMatrix();  
        // draw the arcs     
        rotate(portion* radians(30));
        translate(0,0,portion*step);
        //stroke(0,0,50,150);
        fill(Hue,Saturation,Brightness,40);
        arc( 0,0, radius, radius,0,radians(30));
        for ( int i=0; i<31;i++)
            {
             stroke(Hue,Saturation,Brightness,60);
             line(0,0,0,(radius/2)*cos(radians(i)),(radius/2)*sin(radians(i)),0);
            }  
        popMatrix();
        
}
void draw() { 
        frameRate(60);
        background(0);
        fill(255);
        box(10);
        staticText();
        //reference: https://github.com/mohithingorani/Extruding-Circos-3D-Interactive-Data-Visualization
        if (sectorFlag) {
            for (int portion=0 ; portion< sectors; portion++)
                {
                  if (circleFlag) {
                    drawCircles(portion + 10);
                  }
                  if (arcFlag) {
                    drawArc(portion + 10);
                  }
                  dislanguageayDates(portion);
                }
            }
        
        for (int language=0; language< CONT;language++) { 
            for (int i=0; i< tableLength[language];i++) {
               
                 stroke(language*60+60,Saturation,Brightness,160);
                 strokeWeight(1);
                 noFill();  
                 if (anyFlag) {
                   stroke(250,150);  
                   ellipse(Ptable1[language][i][0], Ptable1[language][i][1], radius * (Ptable1[language][i][0]+Ptable2[language][i][0])/6, (radius * (Ptable1[language][i][1]+Ptable2[language][i][1])/6));
                 }
               
                 if(pythonFlag && language==0) {
                   stroke(#FF6363,150);  //watermelon red
                   beginShape();
                   vertex(-20, -30, 2500);
                   bezierVertex(Ptable1[language][i][0],Ptable1[language][i][1],Ptable1[language][i][2],
                             (Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/1.78,
                          Ptable2[language][i][0],Ptable2[language][i][1],Ptable2[language][i][2]);
                   bezierVertex((Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/3,
                         (Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/3,
                         Ptable2[language][i][0],Ptable2[language][i][1],Ptable2[language][i][2]); 
                   
                   endShape();
                   
                   
                   }
                 if(algorithmFlag && language==1)  //green 
                   {
                   stroke(#63FF63,150);
                   beginShape();
                   vertex(-20, -30, 2500);
                   bezierVertex((Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/1.78,
                         (Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/1.78,
                          Ptable2[language][i][0],Ptable2[language][i][1],Ptable2[language][i][2]); 
                   
                   bezierVertex(Ptable1[language][i][0],Ptable1[language][i][1],Ptable1[language][i][2],
                             (Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/1.78,
                          Ptable2[language][i][0],Ptable2[language][i][1],Ptable2[language][i][2]);
                  
                    endShape();

                   
                   }               
                 if(dataMiningFlag && language==2) {     //light blue
                   stroke(#63FFFF,150);
                   beginShape();
                   vertex(-20, -30, 2500);
                   bezierVertex((Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/1.78,
                         (Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/1.78,
                          Ptable2[language][i][0],Ptable2[language][i][1],Ptable2[language][i][2]); 
                   
                   bezierVertex(Ptable1[language][i][0],Ptable1[language][i][1],Ptable1[language][i][2],
                             (Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/1.78,
                          Ptable2[language][i][0],Ptable2[language][i][1],Ptable2[language][i][2]);
              
                    endShape();
                       
                       
                     } 
                 if(machineLearningFlag && language==3) { //purlanguagee
                  
                   stroke(#6363FF,150);
                   beginShape();
                   vertex(-20, -30, 2500);
                   bezierVertex((Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/1.78,
                         (Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/1.78,
                          Ptable2[language][i][0],Ptable2[language][i][1],Ptable2[language][i][2]); 
                          
                   bezierVertex(Ptable1[language][i][0],Ptable1[language][i][1],Ptable1[language][i][2],
                             (Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/1.78,
                          Ptable2[language][i][0],Ptable2[language][i][1],Ptable2[language][i][2]);
                   
                   
                    endShape();
                   
                   } 
                 if(operatingSystemFlag && language==4) { //peach pink
               
                   stroke(#FF63FF,150);
                   beginShape();
                   vertex(-20, -30, 2500);
                   bezierVertex((Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/1.78,
                         (Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/1.78,
                          Ptable2[language][i][0],Ptable2[language][i][1],Ptable2[language][i][2]); 
                   bezierVertex(Ptable1[language][i][0],Ptable1[language][i][1],Ptable1[language][i][2],
                             (Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/1.78,
                          Ptable2[language][i][0],Ptable2[language][i][1],Ptable2[language][i][2]);
                    endShape();
                   
                   } 
                 if(aiFlag && language==5) {  //yellow
                   
                   stroke(#FFB163,150);
                   beginShape();
                   vertex(-20, -30, 2500);
                   bezierVertex((Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/1.78,
                         (Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/1.78,
                          Ptable2[language][i][0],Ptable2[language][i][1],Ptable2[language][i][2]); 
                          
                   bezierVertex(Ptable1[language][i][0],Ptable1[language][i][1],Ptable1[language][i][2],
                             (Ptable1[language][i][0]+Ptable2[language][i][0])/6,(Ptable1[language][i][1]+Ptable2[language][i][1])/6,(Ptable1[language][i][2]+Ptable2[language][i][2])/1.78,
                          Ptable2[language][i][0],Ptable2[language][i][1],Ptable2[language][i][2]);
                    endShape();
                   
                   
                   }
                }
            }   
      }