/********************************************************
 * Data Visualization - 3D                              *
 * Author: April Cai    
 * Instructor: Rodger Luo
 * Course: MAT259A Winter 2018
 * This program needs to running in Processing 3
 * Usage: You can rotate the 3D visualization using the mouse
  press key p: to locate the key words - python
  press key a: to locate the key words - algorthm
  press key d: to locate the key words - data mining
  press key m: to locate the key words - machine learning
  press key a: to locate the key words - AI
  press key t: to enable the tower shape
  press key p: to locate the key words - python
 ********************************************************/

import peasy.*;
PeasyCam cam;
int CONT=6;
float x,y,z;
int years = 12;
float radius = 400;
int sectors = years*12;
int step=12;
int startYear=2005;
String [] Month = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"};
String cin,cout;
int rows = 8000,columns = 5;
int[][][] cinTable = new int[CONT][rows][columns];
int[][][] coutTable = new int[CONT][rows][columns];

float[][][] Ptable1 = new float[CONT][rows][3];
float[][][] Ptable2 = new float[CONT][rows][3];

float Brightness =100;
float Hue=229;
float Saturation=61;

Table[] table= new Table[CONT];
int []tableLength= new int[CONT];

boolean anyFlag= true;
boolean algorithmFlag= true;  
boolean dataMiningFlag= true;
boolean machineLearningFlag= true;
boolean operatingSystemFlag= true;
boolean aiFlag= true;
boolean pythonFlag= true;
boolean sectorFlag= true;
boolean arcFlag = false;
boolean circleFlag = true;
float[] position= new float[3];

void setup() {
        //size(1300,1000, P3D);
        fullScreen(P3D);
        cam = new PeasyCam(this,0,0,step*years/2*12,3500);
        colorMode(HSB,360,100,100,255);
        cam.setMinimumDistance(50);
        cam.setMaximumDistance(3000);               
        background(0,0,0);     
        
        //load tables
        
        table[0]= loadTable("python.csv","header");
        tableLength[0]=table[0].getRowCount();
            
        table[1]= loadTable("AI.csv","header");
        tableLength[1]=table[1].getRowCount();
              
        table[2]= loadTable("algorithms.csv","header");
        tableLength[2]=table[2].getRowCount();       
        
        table[3]= loadTable("data_mining.csv","header");
        tableLength[3]=table[3].getRowCount();
              
        table[4]= loadTable("machine_learning.csv","header");
        tableLength[4]=table[4].getRowCount();
        
        table[5]= loadTable("operatingsystem.csv","header");
        tableLength[5]=table[5].getRowCount();
              
        for (int language = 0; language< CONT;language++) {
          
            for (int i = 0; i< tableLength[language];i++)
                {
                 cin= table[language].getString(i,0);
                 cout= table[language].getString(i,1);
                  
                int cinNumbers[] = int(splitTokens(cin, "- "));             
                int coutNumbers[] =int(splitTokens(cout, "- "));
                
                for (int matrix = 0; matrix < 3; matrix++)
                    {
                      cinTable[language][i][matrix] =cinNumbers[matrix];
                      coutTable[language][i][matrix] =coutNumbers[matrix];                  
                    }                             
                }
        }    
    //conversion to cylendrical cordinates
    for (int language = 0; language < CONT;language++)
        {
        for (int i = 0; i < tableLength[language]; i++)
             {
              //cin table 
              //reference; https://github.com/mohithingorani/Extruding-Circos-3D-Interactive-Data-Visualization
                Ptable1[language][i][0]= radius/2  * cos((radians(30*cinTable[language][i][1])+radians(cinTable[language][i][2])));    
                Ptable1[language][i][1]= radius/2  * sin((radians(30*cinTable[language][i][1])+radians(cinTable[language][i][2])));
                Ptable1[language][i][2]= (cinTable[language][i][0]-startYear)*step*12+ cinTable[language][i][1]*step;  
                
              //cout table 
              ////reference; https://github.com/mohithingorani/Extruding-Circos-3D-Interactive-Data-Visualization
                Ptable2[language][i][0]= radius/2  * cos((radians(30*coutTable[language][i][1])+radians(coutTable[language][i][2])));   
                Ptable2[language][i][1]= radius/2  * sin((radians(30*coutTable[language][i][1])+radians(coutTable[language][i][2])));
                Ptable2[language][i][2]= (coutTable[language][i][0]-startYear)*step*12+ coutTable[language][i][1]*step;  
              //to make it growing radius
                radius = radius + 0.25;
             }  
             
        }  
      }